/* AMX Mod script.
*
* (c) Copyright 2002, OLO
* This file is provided as is (no warranties).
*
*/

#include <amxmod>
#include <amxmisc>

#define MAX_CLR 7

new ncolors[MAX_CLR][] = {"white","red","green","blue","yellow","magenta","cyan"}
new vcolors[MAX_CLR][3] = {{255,255,255},{255,0,0},{0,255,0},{0,0,255},
													{255,255,0},{255,0,255},{0,255,255}}

new msgchannel = 0
new logfilename[256]

public admin_chat(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new message[192], name[32], players[32], inum, authid[16], userid
	read_args(message,191)
	remove_quotes(message)
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	userid = get_user_userid(id)
	get_players(players,inum)
	log_to_file(logfilename,"Chat: ^"%s<%d><%s><>^" chat ^"%s^"",name,userid,authid,message)
	log_message("^"%s<%d><%s><>^" triggered ^"amx_chat^" (text ^"%s^")",name,userid,authid,message)
	format(message,191,"(ADMINS) %s :   %s",name,message)
	console_print(id,message)
	for(new i = 0; i < inum; ++i){
		if ( get_user_flags(players[i]) & ADMIN_CHAT )
			client_print(players[i],print_chat,message)
	}
	return PLUGIN_HANDLED
}

public admin_say(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new message[192], name[32],authid[16], userid
	read_args(message,191)
	remove_quotes(message)
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	userid = get_user_userid(id)
	client_print(0,print_chat,"(ALL) %s :   %s",name,message)
	console_print(id,"(ALL) %s :   %s",name,message)
	log_to_file(logfilename,"Chat: ^"%s<%d><%s><>^" say ^"%s^"",	name,userid,authid,message)
	log_message("^"%s<%d><%s><>^" triggered ^"amx_say^" (text ^"%s^")",name,userid,authid,message)
	return PLUGIN_HANDLED
}

public admin_psay(id,level,cid){
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED
	new name[32]
	read_argv(1,name,31)
	new priv = cmd_target(id,name,0)
	if (!priv) return PLUGIN_HANDLED
	new length = strlen(name)+1
	new message[192], name2[32],authid[16],authid2[16], userid, userid2
	get_user_authid(id,authid,15)
	get_user_name(id,name2,31)
	userid = get_user_userid(id)	
	read_args(message,191)
	if (message[0]=='"' && message[length]=='"'){// HLSW fix
		message[0]=message[length]=' '
		length+=2
	}
	remove_quotes(message[length])
	get_user_name(priv,name,31)
	if (id&&id!=priv) client_print(id,print_chat,"(%s) %s :   %s",name,name2,message[length])
	client_print(priv,print_chat,"(%s) %s :   %s",name,name2,message[length])
	console_print(id,"(%s) %s :   %s",name,name2,message[length])
	get_user_authid(priv,authid2,15)
	userid2 = get_user_userid(priv)
	log_to_file(logfilename,"Chat: ^"%s<%d><%s><>^" psay ^"%s<%d><%s><>^" ^"%s^"",
			name2,userid,authid,name,userid2,authid2,message[length])
	log_message("^"%s<%d><%s><>^" triggered ^"amx_psay^" against ^"%s<%d><%s><>^" (text ^"%s^")",
		name2,userid,authid,name,userid2,authid2,message[length])
	return PLUGIN_HANDLED
}

public admin_tsay(id,level,cid){
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED
	new color[12], message[192], name[32], authid[16], userid = 0
	read_args(message,191)
	remove_quotes(message)
	parse(message,color,11)
	new found = 0,a = 0
	for(new i=0;i<MAX_CLR;++i)
		if (equal(color,ncolors[i])) {
			a = i
			found = 1
			break
		}
	new length = found ? (strlen(color) + 1) : 0
	if (++msgchannel>6||msgchannel<3)
		msgchannel = 3
	new Float:verpos = 0.55 + float(msgchannel) / 35.0
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	userid = get_user_userid(id)
	set_hudmessage(vcolors[a][0], vcolors[a][1], vcolors[a][2], 0.05, verpos, 0, 6.0, 6.0, 0.5, 0.15, msgchannel)
	show_hudmessage(0,"%s :   %s",name,message[length])
	client_print(0,print_notify,"%s :   %s",name,message[length])
	console_print(id,"%s :   %s",name,message[length])
	log_to_file(logfilename,"Chat: ^"%s<%d><%s><>^" tsay ^"%s^"",name,userid,authid,message[length])
	log_message("^"%s<%d><%s><>^" triggered ^"amx_tsay^" (text ^"%s^") (color ^"%s^")",
		name,userid,authid,message[length],ncolors[a])
	return PLUGIN_HANDLED
}

public plugin_init(){
	register_plugin("Admin Chat","0.9.2","default")
	register_concmd("amx_say","admin_say",ADMIN_CHAT,"<message>")
	register_concmd("amx_chat","admin_chat",ADMIN_CHAT,"<message>")
	register_concmd("amx_psay","admin_psay",ADMIN_CHAT,"<authid, nick or #userid> <message>")
	register_concmd("amx_tsay","admin_tsay",ADMIN_CHAT,"<color> <message>")
	get_time("addons/amx/logs/admin%m%d.log",logfilename,255)
	return PLUGIN_CONTINUE
}
