/* AMX Mod misc.
 *
 * (c) Copyright 2002, OLO
 * This file is provided as is (no warranties).
 */

#if defined _amxmisc_included
	#endinput
#endif
#define _amxmisc_included

stock bool:cmd_access(a,b,c,d){
	if ( !(get_user_flags(a) & b) ){
		console_print(a,"You have no access to that command")
		return false
	}
	if (read_argc() < d){
		new hcmd[32], hinfo[128], hflag
		get_concmd(c,hcmd,31,hflag,hinfo,127,b)
		console_print(a,"Usage:  %s %s",hcmd,hinfo)
		return false
	}
	return true
}

stock bool:access(id,level){
	return ( get_user_flags(id) & level ) ? true : false
}

/*
	flags:
	1 - obey immunity
	2 - allow yourself
	4 - must be alive
	8 - can't be bot
*/
stock cmd_target(id,arg[],flags = 1) {
	new player = find_player("bl",arg)
	if (player){
		new player2 = find_player("blj",arg)
		if (player!=player2){
			console_print(id,"There are more clients matching to your argument")
			return 0		
		}
	}
	else
		player = find_player("c",arg)
	if (!player && arg[0]=='#' && arg[1])
		player = find_player("k",strtonum(arg[1]))
	if (!player){
		console_print(id,"Client with that authid, nick or userid not found")
		return 0
	}
	if (flags & 1){
		if ((get_user_flags(player)&ADMIN_IMMUNITY) && ((flags&2)?(id!=player):true) ){
			new imname[32]
			get_user_name(player,imname,31)
			console_print(id,"Client ^"%s^" has immunity",imname)
			return 0
		}
	}
	if (flags & 4){
		if (!is_user_alive(player)){
			new imname[32]
			get_user_name(player,imname,31)	
			console_print(id,"That action can't be performed on dead client ^"%s^"",imname)
			return 0
		}
	}
	if (flags & 8){
		if (is_user_bot(player)){
			new imname[32]
			get_user_name(player,imname,31)	
			console_print(id,"That action can't be performed on bot ^"%s^"",imname)
			return 0
		}	
	}
	return player
}

/* Clears data under given name. */
native clear_dbase(const name[]);

/* Sets data to given name. 
* Examples:
* set_dbase("myvaules",-1, 7.4 )
* set_dbase("myvaules",-1, "hello world", 12 )
* set_dbase("myvaules",-1, 7 ) */
native set_dbase(const name[],pos = -1, {Float,_}:... );

/* Gets data from given name. 
* Examples:
* get_dbase("myvaules",0, floatvar )
* get_dbase("myvaules",1, temp , 12 )
* a = get_dbase("myvaules", 2 ) */
native get_dbase(const name[],pos, {Float,_}:...  );

/* Returns number of elements under given name. */
native get_dbasenum(const name[]);
